<?php

  require_once("Classes/DataBase.class.php");
  require_once("Classes/Template.class.php");

  // init business object
  $db = new DataBase();

  // AJAX actions
  if (isset($_REQUEST['ajaxWeekevalId'])) {
    // incoming
    $ajaxWeekevalId   = $_REQUEST['ajaxWeekevalId'];
    $ajaxWeekeval     = $db->getWeekevalById($ajaxWeekevalId);
    $ajaxSubscription = $db->getSubscriptionById($ajaxWeekeval->getSubscriptionId());
    // get student
    $ajaxStudent      = $db->getStudentById($ajaxSubscription->getStudentId());
    //outgoing
    echo "comment=".$ajaxWeekeval->getComment()."&mark=".$ajaxWeekeval->getMark()."
          &studentName=".$ajaxStudent->getName()."&studentClass=".$ajaxSubscription->getClass()."
          &studentAge=".$ajaxStudent->getAge()."&studentPhoto=".$ajaxStudent->getPhoto()."
          &weekevalId=".$ajaxWeekevalId;
    die();
  }

  // incoming parameters
  $courseId         = isset($_REQUEST['courseId'])?$_REQUEST['courseId']:-1;
  $weekevalId       = isset($_REQUEST['weekevalId'])?$_REQUEST['weekevalId']:-1;
  $class            = isset($_REQUEST['class'])?$_REQUEST['class']:"";
  $pageNr           = isset($_REQUEST['pageNr'])?$_REQUEST['pageNr']:1;

  // get all data from database
  $NUMSTUDENTSPERPAGE = $db->getConfigpagging();
  if ($weekevalId!=-1) {
    $currWeekeval     = $db->getWeekevalById($weekevalId);
    // get data for this weekeval
    $currSubscription = $db->getSubscriptionById($currWeekeval->getSubscriptionId());
    $courseId         = $currSubscription->getCourseId();
    $studentId        = $currSubscription->getStudentId();
    $currClass        = $currSubscription->getClass();
    $currStudent      = $db->getStudentById($studentId);
  }
  if ($courseId==-1) {
    header("Location: index.php");
    exit(0);
  }
  $currCourse       = $db->getCourseById($courseId);
  $courses          = $db->getCourses();
  $students         = $db->getStudentsByCourseId($courseId, $class, $pageNr, $NUMSTUDENTSPERPAGE,$includeWeekevals=true);
  $numWeeks         = $db->calcNumWeeksByCourseId($courseId);
  $classes          = $db->getClasses($courseId);

  // paging
  $numStudents      = $db->calcNumStudentsByCourseId($courseId, $class);
  $numPages         = ceil($numStudents/$NUMSTUDENTSPERPAGE);
  $urlPrevious      = buildUrl(array('pageNr'=>($pageNr-1)));
  $urlNext          = buildUrl(array('pageNr'=>($pageNr+1)));

  // php actions
  if (isset($_REQUEST["postbackEditPanel"]) && $weekevalId!=-1) {
    $currWeekeval->setComment($_REQUEST['areaComments']);
    $currWeekeval->setMark($_REQUEST['mark']=="A"?"0":$_REQUEST['mark']);
    if (isset($_REQUEST['mark'])) {
      $db->updateWeekevalMark($currWeekeval);
    }
    if (isset($_REQUEST['editCommentOk'])) {
      $db->updateWeekevalComment($currWeekeval);
    }
    header("location: ".buildUrl(array("weekevalId"=>$weekevalId)));
    exit(0);
  }


  // BUILD PAGE
  $tpl = new Template("templates/");
  // set files and blocks
  $tpl->set_file("page_tp", "page.tpl");
  $tpl->set_block("page_tp", "LICOURSE", "licourses");
  $tpl->set_file("showcourse_tp", "showcourse.tpl");
  $tpl->set_block("showcourse_tp", "HEADBLOCK", "headblock");
  $tpl->set_block("showcourse_tp", "CONTENTBLOCK", "contentblock");
  $tpl->set_block("CONTENTBLOCK", "EDITPANEL", "editpanel");
  $tpl->set_block("CONTENTBLOCK", "WEEKHEADER", "weekheaders");
  $tpl->set_block("CONTENTBLOCK", "STUDENTROW", "studentrows");
  $tpl->set_block("STUDENTROW", "MARK", "marks");
  $tpl->set_block("STUDENTROW", "LASTCOL", "lastcol");
  $tpl->set_block("CONTENTBLOCK", "PAGER", "pager");
  $tpl->set_block("PAGER", "NOTFIRST", "notfirst");
  $tpl->set_block("PAGER", "FIRST", "first");
  $tpl->set_block("PAGER", "PAGELINK", "pagelinks");
  $tpl->set_block("PAGELINK", "CURRPAGE", "currpage");
  $tpl->set_block("PAGELINK", "NOTCURRPAGE", "notcurrpage");
  $tpl->set_block("PAGER", "NOTLAST", "notlast");
  $tpl->set_block("PAGER", "LAST", "last");
  $tpl->set_block("CONTENTBLOCK", "CLASSLINK", "classlinks");
  // set values
  $tpl->set_var("COURSENAME", $currCourse->getName());
  $tpl->set_var("CLASS", ($class==""?"&nbsp;":$class));
  $tpl->set_var("WEEKEVALID", $weekevalId);
  // generate panel
  $tpl->set_var("ACTIONMARKPANEL", "#");
  $tpl->set_var("ACTIONMARKPANEL", $_SERVER['PHP_SELF']);
  $tpl->set_var("PAGENR", $pageNr);
  if ($weekevalId!=-1) {
    $tpl->set_var("CLASS", $class);
    $tpl->set_var("CURRSTUDENTPHOTO", $currStudent->getPhoto());
    $tpl->set_var("CURRSTUDENTNAME", $currStudent->getName());
    $tpl->set_var("CURRSTUDENTAGE", $currStudent->getAge());
    $tpl->set_var("CURRSTUDENTCLASS", $currClass);
    $tpl->set_var("WEEKEVALID", $weekevalId);
    $tpl->set_var("COMMENT", $currWeekeval->getComment());
    $tpl->set_var("SELECTED".($currWeekeval->getMark()==-1?"_1":$currWeekeval->getMark()), "selectedmark");
  } else {
    $tpl->set_var("CURRSTUDENTPHOTO", "nopic.jpg"); // just dummy value to prevent validation errors
    $tpl->set_var("WEEKEVALID", -1);
    $tpl->set_var("DISABLEDCLASS", "class=\"disabled\"");
    $tpl->set_var("DISABLED", "disabled=\"disabled\"");
    $tpl->set_var("HIDECLASS", "class=\"hide\"");
  }
  $tpl->parse("editpanel",  "EDITPANEL");
  // generate grid
  for ($i=1; $i<=$numWeeks; $i++) {
    $tpl->set_var("WEEKNR", $i);
    $tpl->parse("weekheaders",  "WEEKHEADER", true);
  }
  $tpl->set_var("NUMROWS", count($students));
  $firstStud = true;
  foreach ($students as $student) {
    $rowClass = ($rowClass=="lightRow"?"darkRow":"lightRow");
    $tpl->set_var("ROWCLASS", $rowClass);
    $tpl->set_var("STUDENTURL",  "showStudent.php?studentId=".$student->getId()."&amp;courseId=".$courseId);
    $tpl->set_var("STUDENTNAME", $student->getName());
    $tpl->set_var("STUDENTBIRTH", $student->getBirth());
    foreach ($student->weekevals as $weekeval) {
      if ($weekeval->getId()==$weekevalId) {
        $tpl->set_var("SELECTEDMARK", "selectedmark");
      } else {
        $tpl->set_var("SELECTEDMARK", "");
      }
      $tpl->set_var("MARKCLASS", "mark".($weekeval->getMark()==-1?"_1":$weekeval->getMark()));
      $tpl->set_var("URLCHANGEMARK", htmlentities(buildUrl(array('weekevalId'=>$weekeval->getId()))));
      $tpl->set_var("WEEKMARK", ($weekeval->getMark()==0?"A":$weekeval->getMark()));
      $tpl->parse("marks", "MARK", true);
    }
    if ($firstStud) {
      $tpl->parse("lastcol", "LASTCOL");
      $firstStud = false;
    } else {
      $tpl->set_var("lastcol", "");
    }
    $tpl->parse("studentrows",  "STUDENTROW", true);
    $tpl->set_var("marks",  "");
  }
  if ($numPages>1) {
    // generate pager
    $tpl->set_var("URLPREVIOUS", htmlentities($urlPrevious));
    $tpl->set_var("URLNEXT", htmlentities($urlNext));
    if ($pageNr==1) {
      $tpl->parse("first",  "FIRST");
    } else {
      $tpl->parse("notfirst", "NOTFIRST");
    }
    for ($i=1; $i<=$numPages; $i++) {
      $tpl->set_var("I", $i);
      $tpl->set_var("currpage", "");
      $tpl->set_var("notcurrpage", "");
      if ($i==$pageNr) {
        $tpl->parse("currpage",  "CURRPAGE");
      } else {
        $pars =
        $tpl->set_var("PAGEURL", htmlentities(buildUrl(array("pageNr"=>$i))));
        $tpl->parse("notcurrpage",  "NOTCURRPAGE");
      }
      $tpl->parse("pagelinks", "PAGELINK", true);
    }
    if ($pageNr==$numPages) {
      $tpl->parse("last",  "LAST");
    } else {
      $tpl->parse("notlast", "NOTLAST");
    }
    $tpl->parse("pager", "PAGER");
  }
  // generate class list
  $tpl->set_var("URL_ALLCLASS", htmlentities(buildUrl(array(), array('weekmarkId', 'courseId', 'pageNr'))));
  foreach ($classes as $class) {
    $urlClass =
    $tpl->set_var("URL_CLASS", htmlentities(buildUrl(array("class"=>$class), array('courseId'))));
    $tpl->set_var("CLASSNAME", $class);
    $tpl->parse("classlinks", "CLASSLINK", true);
  }
  // generate page
  foreach ($courses as $course) {
    $tpl->set_var("NAME_LICOURSE", $course->getName());
    $tpl->set_var("URL_LICOURSE",  "showCourse.php?courseId=".$course->getId());
    $tpl->parse("licourses",  "LICOURSE", true);
  }
  $tpl->set_var("TITLE", "StudentsWatch - view course");
  $tpl->parse("HEADEXTRA", "HEADBLOCK");
  $tpl->parse("CONTENT", "CONTENTBLOCK");
  $tpl->pparse("htmlcode", "page_tp");

?>